
  include "kwirk.h" 
  include "utilo.h" 
  include "tios.h"
  include "huffliboo.h"
  include "gray4lio.h"
  
  xdef code
  xdef _comment
  xdef _ti89


code:
; jsr reclib[init]              ; temp
  jsr gray4lio::on              ; Active le Gris : plan 0 en A6
  move.l gray4lio::plane0,A6
  cmp.b #-1,ingame              ; En cours de jeu
  beq cos1                      ; Si non on passe
mainloop:  
  bsr firstgame                 ; Premier jeu
  cmp.b #123,ingame             ; test fin
  bne su1
  move.b #0,ingame
  bra finmain
su1:
  bsr newgame                   ; Nouveau jeu

cos1:
  move.b #0,ingame              ; On reprends le cours du jeu
;  bsr afffirst                  ; Affiche en premier
  bsr affall                    ; Affiche l'cran de jeu
  bsr playgame                  ; Jeu
  cmp.b #-1,ingame
  beq finmain
  bra mainloop
finmain:  
  jsr gray4lio::off             ; Eteinds le Gris
  rts                           ; Fin du prog


;***************************************************************************
; FIRSTGAME : Presentation + aide
; Entres : Rien
; Sorties : Rien
; Modif   : Rien
firstgame:
        pushall
        move.l gray4lio::plane1,A1
        lea title0(PC),A0
        jsr hufflibo::extract
        move.l gray4lio::plane0,A1
        lea title1(PC),A0
        jsr hufflibo::extract
firstaff:        
        bsr newgame
        move.w #2,-(A7)         ; Choisi gosse fonte
        jsr tios::FontSetSys    ; Choisi fonte
        lea 2(A7),A7            ; Restaure pile
        move.w #4,-(A7)         ; Couleur noir sur blanc
        pea meskw(PC)           ; Niveau
        move.w #4,-(A7)         ; Y=4
        move.w #110,-(A7)       ; X=110
        jsr tios::DrawStrXY     ; Affiche
        lea 8(A7),A7            ; Recupere pile sauf couleur
        pea mesniv(PC)          ; Niveau
        move.w #20,-(A7)        ; Y=14
        move.w #110,-(A7)       ; X=110
        jsr tios::DrawStrXY     ; Affiche
        lea 8(A7),A7            ; Recupere pile sauf couleur
        pea fin_niv(PC)         ; Numero Niveau
        add.l #10,(A7)          ; Corrige decalage
        move.w #20,-(A7)        ; Y=4
        move.w #130,-(A7)       ; X=130
        jsr tios::DrawStrXY     ; Affiche
        lea 10(A7),A7           ; Recupere toute la pile
        move.w #0,-(A7)         ; Choisi petite fonte
        jsr tios::FontSetSys    ; Choisi fonte
        lea 2(A7),A7            ; Restaure pile
        move.w #4,-(A7)         ; Couleur noir sur blanc
        pea h0(PC)              ; Aide 0
        move.w #47,-(A7)        ; Y=47
        move.w #110,-(A7)       ; X=110
        jsr tios::DrawStrXY     ; Affiche
        lea 8(A7),A7            ; Recupere pile sauf couleur
        pea h1(PC)              ; Aide 1
        move.w #55,-(A7)        ; Y=55
        move.w #105,-(A7)       ; X=105
        jsr tios::DrawStrXY     ; Affiche
        lea 8(A7),A7            ; Recupere pile sauf couleur
        pea h2(PC)              ; Aide 2
        move.w #61,-(A7)        ; Y=61
        move.w #105,-(A7)       ; X=105
        jsr tios::DrawStrXY     ; Affiche
        lea 8(A7),A7            ; Recupere pile sauf couleur
        pea h3(PC)              ; Aide 3
        move.w #67,-(A7)        ; Y=67
        move.w #105,-(A7)       ; X=105
        jsr tios::DrawStrXY     ; Affiche
        lea 8(A7),A7            ; Recupere pile sauf couleur
        pea h4(PC)              ; Aide 4
        move.w #73,-(A7)        ; Y=73
        move.w #105,-(A7)       ; X=105
        jsr tios::DrawStrXY     ; Affiche
        lea 8(A7),A7            ; Recupere pile sauf couleur
        pea h5(PC)              ; Aide 5
        move.w #79,-(A7)        ; Y=79
        move.w #105,-(A7)       ; X=105
        jsr tios::DrawStrXY     ; Affiche
        lea 8(A7),A7            ; Recupere pile sauf couleur
        pea h6(PC)              ; Aide 6
        move.w #85,-(A7)        ; Y=85
        move.w #105,-(A7)       ; X=105
        jsr tios::DrawStrXY     ; Affiche
        lea 10(A7),A7           ; Recupere pile et couleur
firstloop:        
        jsr utilo::idle_loop
        cmp.w #264,D0           ; Esc ? ---------------------------------
        bne fesc                ; Si oui on quitte
        move.b #123,ingame
        bra firstend
fesc:   cmp.w #42,D0            ; x ?------------------------------------
        bne ffois               ; Si non on passe
        bra firstaff            ; On reinitialise
ffois:  cmp.w #43,D0            ; + ?------------------------------------
        bne fplus               ; Si non on passe
        move.b niv_nb,D1        ; Sauve dans D1
        move.b niv_cur,D2       ; Sauve dans D2
        cmp.b D1,D2             ; Est-ce le niveau max ?
        beq firstaff            ; Si oui on passe (pas de reini)
        add.b #1,niv_cur        ; additionne 1
        bra firstaff            ; On reinitialise
fplus:  cmp.w #45,D0            ; - ?------------------------------------
        bne fmoins              ; Si non on passe
        cmp.b #0,niv_cur        ; Est-ce le niveau min ?
        beq firstaff            ; Si oui on passe (pas de reini)
        sub.b #1,niv_cur        ; retrait de 1
        bra firstaff            ; On reinitialise
fmoins: cmp.w #4139,D0          ; SND+ ?------------------------------------
        bne fmplus              ; Si non on passe
        move.b niv_nb,D1        ; Sauve dans D1
        sub.l #10,D1            ; Niveaux -10
        move.b niv_cur,D2       ; Sauve dans D2
        cmp.b D1,D2             ; Est-ce le niveau max ?
        bgt firstaff            ; Si oui on passe (pas de reini)
        add.b #10,niv_cur       ; additionne 10
        bra firstaff            ; On reinitialise
fmplus: cmp.w #4141,D0          ; SND- ?------------------------------------
        bne fmmoin              ; Si non on passe
        cmp.b #10,niv_cur       ; Est-ce le niveau min ?
        blt firstaff            ; Si oui on passe (pas de reini)
        sub.b #10,niv_cur       ; retrait de 10
        bra firstaff            ; On reinitialise
fmmoin: bra firstend
firstend:        
        popall
        rts


;****************************************************************************
; PLAYGAME: Jeu.
; Entres : Rien
; Sorties : Rien
; Modif   : Rien
playgame:
        pushall
move:   clr.l D0                ; Efface D0 : On ne sait jamais
        jsr idle                ; Attends une touche en D0
        cmp.w #264,D0           ; Esc ? ---------------------------------
        beq endpl               ; Si oui on quitte
        cmp.w #42,D0            ; x ?------------------------------------
        bne pfois               ; Si non on passe
        bsr newgame             ; On reinitialise
        bsr affall              ; On reinitialise
pfois:  cmp.w #43,D0            ; + ?------------------------------------
        bne pplus               ; Si non on passe
        move.b niv_nb,D1        ; Sauve dans D1
        move.b niv_cur,D2       ; Sauve dans D2
        cmp.b D1,D2             ; Est-ce le niveau max ?
        beq pplus               ; Si oui on passe (pas de reini)
        add.b #1,niv_cur        ; additionne 1
        bsr newgame             ; On reinitialise
        bsr affall              ; On reinitialise
pplus:  cmp.w #45,D0            ; - ?------------------------------------
        bne pmoins              ; Si non on passe
        cmp.b #0,niv_cur        ; Est-ce le niveau min ?
        beq pmoins              ; Si oui on passe (pas de reini)
        sub.b #1,niv_cur        ; retrait de 1
        bsr newgame             ; On reinitialise
        bsr affall              ; On reinitialise
pmoins: cmp.w #4139,D0          ; SND+ ?------------------------------------
        bne pmplus              ; Si non on passe
        move.b niv_nb,D1        ; Sauve dans D1
        sub.l #10,D1            ; Niveaux -10
        move.b niv_cur,D2       ; Sauve dans D2
        cmp.b D1,D2             ; Est-ce le niveau max ?
        bgt pmplus              ; Si oui on passe (pas de reini)
        add.b #10,niv_cur       ; additionne 10
        bsr newgame             ; On reinitialise
        bsr affall              ; On reinitialise
pmplus: cmp.w #4141,D0          ; SND- ?------------------------------------
        bne pmmoin              ; Si non on passe
        cmp.b #10,niv_cur       ; Est-ce le niveau min ?
        blt pmmoin              ; Si oui on passe (pas de reini)
        sub.b #10,niv_cur       ; retrait de 10
        bsr newgame             ; On reinitialise
        bsr affall              ; On reinitialise
pmmoin: cmp.w #116,D0           ; Teacher key ?--------------------------
        bne nteach              ; Si non on saute
        move.b #-1,ingame       ; En cours de jeu
        bra endpl               ; Quitte
nteach: cmp.w #268,D0           ; F1 ?-----------------------------------
        bne noF1                ; Si non on saute
F1:     lea pl_cur(PC),A0       ; On charge dans A0 l'adresse
        add.b #1,(A0)           ; On augmente le joueur
        move.b (A0),D1          ; (A0)->D1
        cmp.b fin_niv(PC),D1    ; Est-ce trop ?
        bne cps1                ; Si non on a fini
        move.b #0,(A0)          ; Sinon on remet a 0
cps1:   clr.l D1                ; On efface D1
        move.b (A0),D1          ; On reprends le numero        
        mulu #4,D1              ; On multiplie
        lea players(PC),A2      ; On pointe sur les joueurs
        add.l D1,A2             ; On pointe sur le courant
        cmp.w #-1,(A2)          ; Inutiloise ?
        beq F1                  ; Sinon on change
        bsr affplayer           ; On affiche pour changer joueur
        bsr affall              ; On reaffiche tout pour scrolling
        bra cfin                ; Fini
noF1:        
        clr.l D3                ; On efface D3---------------------------
        move.b pl_cur,D3        ; On charge le numero du joueur
        mulu.w #4,D3            ; On multiplie par trois.
        lea players(PC),A5      ; On charge les joueurs
        add.w D3,A5             ; On selectionne le joueur en cours
        lea niv(PC),A0          ; On charge le niveau en A0
        add.w (A5),A0           ; A0 pointe sur le joueur 
        
        cmp.w #338,D0           ; Gauche ?
        beq c_ga                ; Si oui on va a c_ga
        cmp.w #337,D0           ; Haut ?
        beq c_ha                ; Si oui on va en c_ha
        cmp.w #344,D0           ; Droite ?
        beq c_dr                ; Si oui on va en c_dr
        cmp.w #340,D0           ; Bas ?
        beq c_ba                ; Si oui on va en _ba
        jmp cfin                ; Fin des cas : on va en cfin 

c_ga:   move.l #-1,D1           ; Decalage de -1
        jmp cmov
c_dr:   move.l #1,D1            ; Decalage de 1
        jmp cmov
c_ha:   move.l #-20,D1          ; Decalage de -20
        jmp cmov
c_ba:   move.l #20,D1           ; Decalage de 20
        jmp cmov
cmov:   bsr testcase            ; Teste et deplace
        bsr affall              ; On affiche tout
        cmp #$1234,D7           ; Test de gain
        beq gain                ; Si oui on quitte
cfin:   jmp move                ; On recommence
gain:   move.b #0,(A0)          ; Efface le joueur
        lea players(PC),A0      ; Charge les joueurs
        clr.l D0                ; Efface D0
        move.b pl_cur,D0        ; Met joueur dans D0
        mulu #4,D0              ; Deplacement
        add.l D0,A0             ; Pointe sur joueur courant
        move.w #-1,(A0)         ; Inactif
        lea players(PC),A0      ; Charge les joueurs
        move.l #0,D0            ; Joueur 0
j_bcl:  cmp.w #-1,(A0)          ; Joueur en service
        beq j_s1                ; Si non on saute
        move.b D0,pl_cur        ; Met dans joueur courant
        bsr affall
        jmp move                ; Retourne au jeu
j_s1:   add.l #1,D0             ; Joueur suivant
        add.l #4,A0             ; Pointe sur le suivant
        cmp.b fin_niv(PC),D0    ; Est-ce fini ?
        bne j_bcl               ; Si non on boucle
        move.b niv_nb,D1        ; Sauve dans D1
        move.b niv_cur,D2       ; Sauve dans D2
        cmp.b D1,D2             ; Est-ce le niveau max ?
        beq finni               ; Si oui on passe (pas de reini)
        add.b #1,niv_cur        ; additionne 1
        bsr newgame             ; On reinitialise
        bsr affall              ; On reinitialise
        jmp move                ; On recommence
finni:  jsr utilo::clr_scr       ; Efface ecran
        move.w #2,-(A7)         ; Choisi grosse fonte
        jsr tios::FontSetSys      ; Choisi fonte
        lea 2(A7),A7            ; Restaure pile
        move.w #4,-(A7)         ; Couleur noir sur blanc
        pea mesgain(PC)         ; Message de gain
        move.w #55,-(A7)        ; Y=55
        move.w #100,-(A7)       ; X=100
        jsr tios::DrawStrXY     ; Affiche
        lea 10(A7),A7           ; Recupere pile
        bsr eff_gray            ; Efface le gris
        jsr utilo::idle_loop     ; Attends
endpl:  popall
        rts                     ; Retour a l'appelant



;****************************************************************************
; TESTCASE : Test le dplacement dans une direction.
; Entres : A0.l : Adresse de la Position 
;           D1.l : Direction (decalage : g=-1, d=1, h=-20, b=20)
; Sorties : D7.w : 0 = ok,$1234=gagne autre sinon
; Modif   : D7 (!)
testcase:
        clr.l D7                ; Suppose vrai au dpart
        push D6                 ; Sauve D6
        push D5                 ; Sauve D5
        push D4                 ; Sauve D4
        push D3                 ; Sauve D3
        push D2                 ; Sauve D2
        push D0                 ; Sauve D0
        push A1                 ; Sauve A1
        push A2                 ; Sauve A2
        push A3                 ; Sauve A3
        clr.l D3                ; Vide D3
        move.b 0(A0,D1),D3      ; Charactere dans case objectif
        move.b D3,D5            ; D3->D5
        and.b #$F0,D5           ; Ne garde que les liens
        and.b #$0F,D3           ; Ne garde que la nature de la case
        cmp.b #1,D3             ; Mur ?
        beq tcbad               ; Si oui : fini
        cmp.b #2,D3             ; Sortie ?
        beq tstcwn              ; Si oui : gagne !
        cmp.b #3,D3             ; Trou ?
        beq tcbad               ; Si oui : fini
        cmp.b #4,D3             ; Joueur 1 ?
        beq tcbad               ; Si oui : fini
        cmp.b #5,D3             ; Joueur 2 ?
        beq tcbad               ; Si oui : fini
        cmp.b #6,D3             ; Joueur 3 ?
        beq tcbad               ; Si oui : fini
        cmp.b #7,D3             ; Joueur 4 ?
        beq tcbad               ; Si oui : fini
        cmp.b #8,D3             ; Bloc sur sol ?
        bne tts1                ; Si non on passe

        push D3                 ; Sauve D3
        bsr getortho            ; direction ortho dans D4, et D5 masque en D6
        move.l A0,A1            ; A0->A1
        add.w D1,A1             ; A0+D1->A1 : pointe sur case suivante
        push A1                 ; Sauve A1
        move.b (A1),D0          ; Charge le caractere
        clr.l D3                ; Efface D3
        move.w D4,D3            ; Garde le decalage dans D3
        ext.l D3                ; Etends le signe au double mot.
        swap D4                 ; D4 : masque
        and.b D4,D0             ; test si on y va
        cmp.b #0,D0             ; case au dessus ?
        bne tsbdep              ; Si non on va pour le bas
tshbcl: add.l D3,A1             ; Ligne precedente
        move.b (A1),D0          ; charge caractere
        and.b D4,D0             ; applique le masque
        push A1                 ; Sauve l'adresse
        bsr deptest             ; deplace la ligne
        move.b (A1),D2          ; prends octet
        pop A1                  ; Restaure l'adresse
        and.b #$0F,D2           ; garde le type
        cmp.b #0,D2             ; vide ?
        beq tshok               ; si oui ok
        cmp.b #3,D2             ; trou ?
        beq tshok               ; si oui ok
        move.l #-1,D7           ; sinon foutu
tshok:  cmp.b #0,D0             ; teste si fini
        bne tsbdep              ; si oui on va a la suite
        bra tshbcl              ; sinon on boucle
tsbdep: pop A1                  ; Recupere A1
        push A1                 ; Resauve A1
        move.b (A1),D0          ; Charge le caractere
        clr.l D3                ; Efface D3
        move.w D5,D3            ; Garde le decalage dans D3
        ext.l D3                ; Etends le signe au double mot
        swap D5                 ; D5 : masque
        and.b D5,D0             ; test si on y va
        cmp.b #0,D0             ; case au dessous ?
        bne tsfdep              ; Si non on fini
tsbbcl: add.l D3,A1             ; Ligne precedente
        move.b (A1),D0          ; charge caractere
        and.b D5,D0             ; applique le masque
        push A1                 ; sauve l'adresse
        bsr deptest             ; deplace le test
        move.b (A1),D2          ; prends octet
        pop A1                  ; Restaure l'adresse
        and.b #$0F,D2           ; garde le type
        cmp.b #0,D2             ; vide ?
        beq tsbok               ; si oui ok
        cmp.b #3,D2             ; trou ?
        beq tsbok               ; si oui ok
        move.l #-1,D7           ; sinon foutu
tsbok:  cmp.b #0,D0             ; teste si fini
        bne tsfdep              ; si oui on va a la suite
        bra tsbbcl              ; sinon on boucle
tsfdep: pop A1                  ; On recupere A1
        bsr deptest             ; deplace le test
        move.b (A1),D2          ; prends octet
        and.b #$0F,D2           ; garde le type
        cmp.b #0,D2             ; vide ?
        beq tsok                ; si oui ok
        cmp.b #3,D2             ; trou ?
        beq tsok                ; si oui ok
        move.l #-1,D7           ; sinon foutu
tsok:   pop D3                  ; recupere D3
        cmp.l #0,D7             ; teste si erreur
        bne tcbad               ; si non foutu

tts1:   cmp.b #9,D3             ; Bloc sur trou ?
        beq tcbad               ; Si oui c'est foutu.
        cmp.b #10,D3            ; Pivot tourniquet ?     
        beq tcbad               ; Si oui : mauvais
        cmp.b #11,D3            ; Tourniquet sol ?
        bne tts2                ; Si non on passe
        move.l A0,A1            : A0->A1
        add.w D1,A1             ; case suivante de la suivante
        move.b 0(A1,D1),D4      ; on prend le numero
        and #$0F,D4             ; on garde la nature
        cmp #0,D4               ; est-ce vide ?
        beq tcs3                ; oui : c'est bon
        cmp #3,D4               ; serais-ce un trou ??
        beq tcs3                ; oui : sauve
        bra tcbad               ; sinon c'est foutu
tcs3:   bsr reppivot            ; Recherche du pivot et du sens
        push D3                 ; Sauve D3
        move.l #0,D3            ; Suppose ok
        move.l #6,D6            ; 6eme bit a tester
        move.l #-1,D2           ; Sens trigo, gauche.
        move.l #-20,D5          ; Haut test
        bsr tstrot              ; Effectue rotation
        move.l #7,D6            ; 7eme bit a tester
        move.l #20,D2           ; Sens trigo, bas.
        move.l #-1,D5           ; Gauche teste
        bsr tstrot              ; Effectue rotation
        move.l #4,D6            ; 4eme bit a tester
        move.l #1,D2            ; Sens trigo, droite.
        move.l #20,D5           ; Bas teste
        bsr tstrot              ; Effectue rotation
        move.l #5,D6            ; 5eme bit a tester
        move.l #-20,D2          ; Sens trigo, haut.
        move.l #1,D5            ; Droite teste
        bsr tstrot              ; Tourne
        move.l D3,D0            ; Recupere val tst dans D0
        pop D3                  ; Recupere D3
        cmp.b #0,D0             ; Test si ok
        bne tcbad               ; Si non c'est foutu

tts2:   cmp.b #12,D3            ; Tourniquet trou
        beq tcbad               ; Si oui passage impossible
ttyes:  
        cmp.b #8,D3             ; Bloc sur sol ?
        bne tts4                ; Sinon on passe au suivant
        bsr getortho            ; direction ortho dans D4, et D5 masque en D6
        move.l #-1,D2           ; Suppose tous sur trou
        move.l A0,A1            ; A0->A1
        add.w D1,A1             ; A0+D1->A1 : pointe sur case suivante
        push A1                 ; Sauve A1
        move.b (A1),D0          ; Charge le caractere
        clr.l D3                ; Efface D3
        move.w D4,D3            ; Garde le decalage dans D3
        ext.l D3                ; Etends le signe au double mot.
        swap D4                 ; D4 : masque
        and.b D4,D0             ; test si on y va
        cmp.b #0,D0             ; case au dessus ?
        bne tbadep              ; Si non on va pour le bas
thabcl: add.l D3,A1             ; Ligne precedente
        move.b (A1),D0          ; charge caractere
        and.b D4,D0             ; applique le masque
        bsr depligne            ; deplace la ligne
        cmp.b #0,D0             ; teste si fini
        bne tbadep              ; si oui on va a la suite
        bra thabcl              ; sinon on boucle
tbadep: pop A1                  ; Recupere A1
        push A1                 ; Resauve A1
        move.b (A1),D0          ; Charge le caractere
        clr.l D3                ; Efface D3
        move.w D5,D3            ; Garde le decalage dans D3
        ext.l D3                ; Etends le signe au double mot
        swap D5                 ; D5 : masque
        and.b D5,D0             ; test si on y va
        cmp.b #0,D0             ; case au dessous ?
        bne tfdep               ; Si non on fini
tbabcl: add.l D3,A1             ; Ligne precedente
        move.b (A1),D0          ; charge caractere
        and.b D5,D0             ; applique le masque
        bsr depligne            ; deplace la ligne
        cmp.b #0,D0             ; teste si fini
        bne tfdep               ; si oui on va a la suite
        bra tbabcl              ; sinon on boucle
tfdep:  pop A1                  ; On recupere A1
        bsr depligne            ; deplace la ligne en cours
        cmp.b #-1,D2            ; Est-ce tous dans trou ?
        bne tts4                ; Non, on saute
        bsr getortho            ; direction ortho dans D4, et D5 masque en D6
        move.l A0,A1            ; A0->A1
        add.w D1,A1             ; A0+D1->A1 : pointe sur case suivante
        add.w D1,A1             ; A0+2*D1->A1 : pointe sur le debut du bloc mu
        push A1                 ; Sauve A1
        move.b (A1),D0          ; Charge le caractere
        clr.l D3                ; Efface D3
        move.w D4,D3            ; Garde le decalage dans D3
        ext.l D3                ; Etends le signe au double mot.
        swap D4                 ; D4 : masque
        and.b D4,D0             ; test si on y va
        cmp.b #0,D0             ; case au dessus ?
        bne cbadep              ; Si non on va pour le bas
chabcl: add.l D3,A1             ; Ligne precedente
        move.b (A1),D0          ; charge caractere
        and.b D4,D0             ; applique le masque
        bsr effline             ; efface la ligne
        cmp.b #0,D0             ; teste si fini
        bne cbadep              ; si oui on va a la suite
        bra chabcl              ; sinon on boucle
cbadep: pop A1                  ; Recupere A1
        push A1                 ; Resauve A1
        move.b (A1),D0          ; Charge le caractere
        clr.l D3                ; Efface D3
        move.w D5,D3            ; Garde le decalage dans D3
        ext.l D3                ; Etends le signe au double mot
        swap D5                 ; D5 : masque
        and.b D5,D0             ; test si on y va
        cmp.b #0,D0             ; case au dessous ?
        bne cfdep               ; Si non on fini
cbabcl: add.l D3,A1             ; Ligne precedente
        move.b (A1),D0          ; charge caractere
        and.b D5,D0             ; applique le masque
        bsr effline             ; efface la ligne
        cmp.b #0,D0             ; teste si fini
        bne cfdep               ; si oui on va a la suite
        bra cbabcl              ; sinon on boucle
cfdep:  pop A1                  ; On recupere A1
        bsr effline             ; efface la ligne en cours
tts4:   cmp.b #11,D3            ; Tourniquet (ext et sur sol) ?
        bne depl                ; Sinon on deplace le joueur
        bsr reppivot            ; on repere le pivot
        move.b (A1),D0          ; on chope le pivot
        
        move.l #6,D6            ; 6eme bit a tester
        move.l #-1,D2           ; Sens trigo, gauche.
        move.l #$00D00070,D5    ; Attributs
        bsr rotate              ; Effectue rotation
        move.l #7,D6            ; 7eme bit a tester
        move.l #20,D2           ; Sens trigo, bas.
        move.l #$00B000E0,D5    ; Attributs
        bsr rotate              ; Effectue rotation
        move.l #4,D6            ; 4eme bit a tester
        move.l #1,D2            ; Sens trigo, droite.
        move.l #$007000D0,D5    ; Attributs
        bsr rotate              ; Effectue rotation
        move.l #5,D6            ; 5eme bit a tester
        move.l #-20,D2          ; Sens trigo, haut.
        move.l #$00E000B0,D5    ; Attributs
        bsr rotate              ; Tourne
        move.b (A1),D2          ; Prends le pivot
        and.b #$F0,D2           ; Garde les attributs
        cmp.b #1,D4             ; Sens trigo
        bne atrho               ; Sinon on saute
        lsl.b #1,D2             ; Tourne les attributs
        bcc atrf                ; Si pas mis on saute
        or.b #%00010000,D2      ; Met le bit 4
        bra atrf                ; Fin
atrho:  lsr.b #1,D2             ; Tourne les attributs
        btst #3,D2              ; Si pas mis on saute
        beq atrf                ; Si non on saute
        or.b #%10000000,D2      ; Met le bit 7
atrf:   or.b #$0A,D2            ; Met le pivot
        move.b D2,(A1)          ; Remet en place le pivot
        move.l A0,A1            ; A0->A1
        add.l D1,A1             ; A0+D1->A1 : pointe sur dest
        cmp.b #0,(A1)           ; Teste si vide
        beq depl                ; Si vide on ne deplace que d'un

        add.l D1,A1             ; Case suivante
        move.b (A1),D2          ; On prend la case
        sub.l D1,A1             ; Reprend la case
        and.b #$0F,D2           ; Garde case
        cmp.b #03,D2            ; Trou ?
        bne depl2               ; On deplace 2x
        move.b #0,(A0)          ; On efface joueur
        push A0                 ; Sauve A0
        add.l D1,A0             ; Additionne 2x D1
        add.l D1,A0             ;  pour simuler deplacement
        push A0                 ; Sauve case dest.
        neg.l D1                ; On inverse le mouvement
        jsr testcase            ; On refait sens inverse
        pop A0                  ; Restaure A0 case dest
        move.b #03,(A0)         ; Restaure le trou
        pop A0                  ; Restaure position joueur
        move.b pl_cur,(A0)      ; Met joueur courant
        add.b #4,(A0)           ; Ajuste
        sub.w D1,(A5)           ; Redeplace joueur
        sub.w D1,(A5)           ; Pour revenir normal
        bra tstfin              ; On finit

depl2:  add.w D1,(A5)           ; Sinon Deplace la position du joueur (2x)
        add.w D1,(A5)           ; Deplace deux fois
        move.l A0,A1            ; A0->A1
        add.l D1,A1             ; A0+D1->A1
        add.l D1,A1             ; A0+2*D1->A1
        move.b (A0),0(A1)       ; Bouge le joueur dans le niveau
        move.b #0,(A0)          ; Efface l'ancien joueur
        bra tstfin              ; Pas bouger le joueur 3x !
depl:   add.w D1,(A5)           ; Deplace la position du joueur
tcvert: move.b (A0),0(A0,D1)    ; Bouge le joueur dans le niveau
        move.b #0,(A0)          ; Efface l'ancien joueur
        bra tstfin              ; On termine, tout s'est bien pass.
tcbad:  move.l #$FFFF,D7        ; On met faux dans resultat
        bra tstfin              ; On fini
tstcwn: move.l #$1234,D7        ; On met gain dans resultat
tstfin: pop A3                  ; On recupere A3
        pop A2                  ; On recupere A2
        pop A1                  ; On recupere A1
        pop D0                  ; On recupere D0
        pop D2                  ; On recupere D2
        pop D3                  ; On recupere D3
        pop D4                  ; On recupere D4
        pop D5                  ; On recupere D5
        pop D6                  ; On recupere D6
        rts                     ; Retour a l'applelant

        
;****************************************************************************
; IDLE    : Teste si une touche est presse (et bouge joueur)
; Entres : Rien
; Sorties : D0.w : Touche
; Modif   : D0
idle:                                   ; Extraite de utilo.ASM
        movem.l a0-a6/d1-d7,-(a7)       ; Sauve tous les registres sauf D0
        
midle_start:
        move.l  #$1770,APD_TIMER        ; Reset APD timer (1)
        clr.w   APD_FLAG                ; Reset APD timer (2)
        move.l #0,D7            ; Initialise le compteur 
mwait_idle:
        add.l #1,D7             ; L'incremente
        cmp.l #30000,D7          ; Suffisament attendu ? // TI-89 *3000
        bne midnon              ; Si non on saute
        move.l #0,D7            ; Si oui on rinit
        pushall                 ; On sauve tout
        move.b pl_cur,D3        ; On charge le numero du joueur
        move.l D3,D4            ; On met D3->D4
        add.l #4,D4             ; Numero de sprite
        mulu.w #4,D3            ; On multiplie par trois.
        lea players(PC),A5      ; On charge les joueurs
        add.w D3,A5             ; On selectionne le joueur en cours
        move.w (A5),D7          ; Lit la position
        divu #20,D7             ; Divise par 20
        clr.l D0                ; Efface D0
        clr.l D1                ; Efface D1     
        move.w D7,D1            ; Garde le nb de lignes
        swap.l D7               ; Inverse
        move.w D7,D0            ; Nombre de colo
        mulu.w #12,D4           ; Pointe sur sprite
        neg.w 2(A5)             ; -2(A5) 
        add.w #2,2(A5)          ; 1-2(A5)
        lea des(PC),A0          ; Pointe sur les dessins
        add.l D4,A0             ; Pointe sur joueur
        add.w 2(A5),A0          ; +1 ou +0 
        clr.l D2                ; Efface les attributs
        cmp.l #21,D0
        bge midnaf
        bsr affbloc             ; affiche
midnaf: popall
midnon: ;stop    #$2000
        tst.w   APD_FLAG                ; time for APD?
        beq     mno_apd                 ; no -- do not shut down
mdo_apd:
        trap    #4
        bra     midle_start
mno_apd:
        tst.w   KEY_PRESSED_FLAG                 ; has a key been pressed?
        beq     mwait_idle
        move.l  #$1770,APD_TIMER        ; reset APD timer (1)
        move.w  GETKEY_CODE,d0
        clr.w   KEY_PRESSED_FLAG                 ; clear key buffer
mtry_key_off:
        cmp.w   #$210B,d0               ; Test si c'est la touche Off
        bne     mnot_key_off
        bra     mdo_apd
mnot_key_off:
        movem.l (a7)+,a0-a6/d1-d7
        rts

 include "kwirk.inc"

niv_cur   dc.b 0                ; Numero du niveau courant
niv_nb    dc.b 33               ; Nombre de niveaux - 1

pl_cur    dc.b 0                ; Joueur courant 1
players   dc.w 104,0            ; Joueur 1 :    Decalage, Deplacement
          dc.w 106,0            ; Joueur 2
          dc.w 108,0            ; Joueur 3
          dc.w 110,0            ; Joueur 4
ingame    dc.b 0                ; $FF si en jeu
mesniv    dc.b "N:",0           ; Niveau en cours
mesgain   dc.b " FIN ",0        ; Message de fin
h0        dc.b "      Aide  ",0 ; Aide
h1        dc.b "F1:Ch joueur",0   ; Aide 1 Change de joueur
h2        dc.b "x :Nouveau",0   ; Aide 2 Recommence
h3        dc.b "- :Precedent",0   ; Niveau precedent
h4        dc.b "+ :Suivant",0   ; Niveau suivant
h5        dc.b "t :Teacher",0   ; Teacher key
h6        dc.b "ESC : Fin",0    ; Quitte
h7        dc.b "Kwirk (RPS)",0,0; Version
meskw     dc.b "KWIRK",0
_comment  dc.b "Kwirk v1.1b. (RPS)",0
 
niveaux incbin "niveaux.huf"
title0 incbin "plane0.huf"
title1 incbin "plane1.huf"

 END
